!c Description:
!c   ͤ˶ᤤη׻.  
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-02-25    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

module interface_equivmol
  interface

     subroutine EquivMol(B, struct, phase, temp, mu, mol)
       real(8), intent(in)     :: temp            !
       real(8), intent(inout)  :: B(:)            !
       real(8), intent(in)     :: mu(:)           !إݥƥ󥷥
       real(8), intent(in)     :: struct(:,:)     !ؼ˴ޤޤ븵ǿ
       real(8), intent(inout)  :: mol(:)          !ؼΥ
       integer(8), intent(in)  :: phase(:)        !ֹ
     end subroutine EquivMol

  end interface
end module interface_equivmol





subroutine equivmol(B, struct, phase, temp, mu, mol)
  use prm_phys, only: gasr
  use interface_phase_pack
  
  implicit none
  real(8), intent(in)     :: temp            !
  real(8), intent(inout)  :: B(:)            !
  real(8), intent(in)     :: mu(:)           !إݥƥ󥷥
  real(8), intent(in)     :: struct(:,:)     !ؼ˴ޤޤ븵ǿ
  real(8), intent(inout)  :: mol(:)          !ؼΥ
  integer(8), intent(in)  :: phase(:)        !ֹ

  real(8), allocatable    :: lambda(:)       !ѷ
  real(8), allocatable    :: mol_new(:)      !
  real(8), allocatable    :: B_phi(:)        !
  real(8), allocatable    :: struct_dot_B(:) !struct  B 
  real(8), allocatable    :: emol(:) 
  integer(8)              :: i 
  integer(8)              :: smax
  integer(8)              :: emax
  integer(8), allocatable    :: phase_tmp(:)     


!!!
!!!
!!!  
  !礭
  smax = size(struct, 1)
  emax = size(struct, 2)
  
  !γ
  allocate(mol_new(smax), &
       & lambda(smax), &
       & B_phi(smax), &
       & struct_dot_B(smax), &
       & emol(emax))
  
  !ͤ
  lambda = 1.0D0

  allocate(phase_tmp(smax))
  phase_tmp = phase
  call phase_pack(phase_tmp)
 
  
!!!
!!!ʿ׻
!!!
  !B_phi ˤֹԤͤ
  do i = 1, smax
     B_phi(i) = B(emax+ phase_tmp(i))
  end do
  
  !struct  B ѤȤ
  do i = 1, smax
     struct_dot_B(i) = sum(B(1: emax) * struct(i, 1: emax)) 
  end do
  
!!!
!!!ʿշ׻
!!!
  !ʿη׻()
  mol_new = &
       & - mol * mu / (gasr * temp) &
       & + mol * B_phi & 
       & + mol * struct_dot_B

!!!
!!!Ͳ
!!!줿椬ɤ줫 1 ĤǤʤѿ lammda ˥å. 
!!!
  lambda = merge(mol / (mol - mol_new), lambda, mol_new <= 0.0D0)
  mol_new = mol - minval(lambda) * 9.99D-1 * (mol - mol_new)
  
  !֤ͤ
  mol = mol_new
  
!!!  
!!!
!!!
  deallocate(mol_new, &
       & lambda, &
       & B_phi, &
       & struct_dot_B, &
       & emol)

end subroutine equivmol





